program TopSecret;
uses Crt;

const
	MAXDLUG = 120; { maksymalna dlugosc wiersza tekstu }
	MAXNR   = 533; { maksymalna liczba przetwarzanych wierszy }

type
	Wiersz = string[MAXDLUG]; { takimi wierszami operujemy }
	Bufor  = array[1..MAXNR] of Wiersz; { bufor na tekst }

var
	f : text; { plik do kodowania/po kodowaniu }
	Tekst : Bufor; { tu bedzie przechowywany tekst }
	IleWierszy : integer; { biezaca liczba wierszy w tekscie }
	Klucz : longint; { wartosc klucza do (de)szyfrowania }
	Tryb : byte; { 1: szyfrowanie, 2: deszyfrowanie }
	i : integer; { pomocniczy licznik }
        Poczatek,OstKol,OstRzad: Word;
        Done: Boolean;
        Ch: Char;

procedure StartGrafiki;
begin
  CheckBreak:=False;
  Poczatek:=LastMode;
  TextMode(Lo(LastMode)+Font8x8);
  OstKol:=Lo(WindMax)+1;
  OstRzad:=Hi(WindMax)+1;
  TextBackground(Black);
  TextColor(2);
  {Dec(OstRzad,80 div OstKol); {ostatni rzad wolny}
  gotoxy(1,1);
  for i:=1 to 80 do write('');
  gotoxy(1,3);
  for i:=1 to 80 do write('');
  gotoxy(1,49);
  for i:=1 to 80 do write('');
  for i:=1 to 49 do begin gotoxy(1,i); write(''); gotoxy(80,i); write(''); end;
  gotoxy(1,1); write('');
  gotoxy(80,1); write('');
  gotoxy(1,49); write('');
  gotoxy(80,49); write('');
  textcolor(15);
  gotoxy(30,2);write('TOP SECRET - Koder');
  window(2,4,79,48);
end;

function CzytajTekst(var BuforWej:Bufor):integer;
{ czyta tekst do BuforaWej, zwraca liczbe przeczyt. wierszy }

var
	NazwaPliku : string; { nazwa pliku wejsciowego }
	i : integer; { pomocniczy licznik }

begin
        repeat
        writeln;
	write('Podaj nazwe pliku zrodlowego: ');
       	readln(NazwaPliku); { wczytaj nazwe pliku... }
	assign(f,NazwaPliku);
       {$I-}
	reset(f); { ... otworz go }
       {$I+}
        if IOResult <> 0 then begin
         writeln('Plik nie zostal znaleziony !!!');
         Write('ENTER - Jeszcze raz ESC - Koniec');
         repeat
          ch:=readkey;
         until ch in [#27,#13];
         case ch of
          #27: begin TextColor(7);
               Textbackground(0);
               TextMode(Poczatek);
               window(1,1,80,25);
               ClrScr;
               Halt;
               end;
          #13: begin Clrscr; done:=false; end;
         end;
        end
        else done:=true;
        until done;
	i:=0; { pierwotna wartosc licznika }
	while not eof(f) do
		begin
			Inc(i); { kolejny wiersz }
			readln(f,BuforWej[i]); {wczytaj wiersz, do 120 znakow!}
		end;
	close(f);
	CzytajTekst:=i { zwroc liczbe przeczytanych wierszy }
end;

procedure PiszTekst(var BuforWyj:Bufor;IleWierszy:integer);
{ zapisuje IleWierszy z BuforaWyj do pliku tekstowego }

var
	NazwaPliku : string; { nazwa pliku wejsciowego }
	i : integer; { pomocniczy licznik }

begin
        writeln;
	write('Podaj nazwe pliku docelowego: ');
	readln(NazwaPliku); { jak poprzednio }
	assign(f,NazwaPliku);
	rewrite(f); { utworz plik docelowy lub skasuj stary (!) }
	for i:=1 to IleWierszy do
		writeln(f,BuforWyj[i]); { zapisz wiersze do pliku docel. }
	close(f)
end;

function Szyfruj(s:Wiersz):Wiersz;
{ szyfruje pojedynczy wiersz tekstu }

var
	i : byte; { wystarczy licznik bajtowy ! }

begin
	for i:=1 to Length(s) do { do wszystkich znakow wiersza }
		s[i]:=chr(ord(s[i])+Random(128)); { dodaj liczbe losowa }
	Szyfruj:=s { zwroc zaszyfrowany tekst }
end;

function Deszyfruj(s:Wiersz):Wiersz;

var
	i : byte;

begin
	for i:=1 to Length(s) do { od wszystkich znakow wiersza }
		s[i]:=chr(ord(s[i])-Random(128)); {odejmij liczbe losowa}
	Deszyfruj:=s { zwroc odszyfrowany tekst }
end;

begin { program }
        clrscr;
        StartGrafiki;
        TextColor(7);
        repeat
        writeln;
        writeln('Podaj wartosc klucza (liczba calkowita od -2147483648 do 2147483647) ');
	write('Klucz: ');
       {$I-}
        readln(Klucz);
       {$I+}
        if IOResult <> 0 then begin
         writeln('Liczba zostala blednie okreslona !!!');
         Write('ENTER - Jeszcze raz ESC - Koniec');
         repeat
          ch:=readkey;
         until ch in [#27,#13];
         case ch of
          #27: begin TextColor(7);
               Textbackground(0);
               TextMode(Poczatek);
               window(1,1,80,25);
               ClrScr;
               Halt;
               end;
          #13: begin Clrscr; done:=false; end;
         end;
        end
        else done:=true;
        until done;
	RandSeed:=Klucz; {wartosc startowa dla generatora losowego}
	IleWierszy:=CzytajTekst(Tekst);
        writeln;
	repeat { pytaj az do skutku }
		write('Czy chcesz ? [1] szyfrowac; [2] deszyfrowac: ');
		readln(Tryb);
	until Tryb in [1,2]; { o tym zaraz }
	if Tryb = 1 then { szyfrowanie }
		for i:=1 to IleWierszy do { wszystkich wierszy }
			Tekst[i]:=Szyfruj(Tekst[i])
	else  { deszyfrowanie }
		for i:=1 to IleWierszy do { wszytskich wierszy }
			Tekst[i]:=Deszyfruj(Tekst[i]);
	PiszTekst(Tekst,IleWierszy); { zapisz wynik (de)szyfrowania }
        writeln;
        write('Program zakonczyl sie, nacisnij ENTER...');
        repeat
         ch:=readkey;
        until ch=#13;
        TextColor(7);
        Textbackground(0);
        TextMode(Poczatek);
        window(1,1,80,25);
        ClrScr;
end. { program TopSecret}
